//  test_selection.hpp
//
//  Copyright 2007 University of Pittsburgh.
//  U of Pittsburgh coding done by Brady Hunsaker and Mustafa Baz.
//
//  This file is part of STOP (Selection Tool for Optimization Parameters).
//
//  The contents of this file are subject to the Common Public License
//  1.0.  (the "License"); you may not use this file except in
//  compliance with the License. You should have received a copy of
//  the Common Public License along with STOP.
//
//  Software distributed under the License is distributed on an "AS
//  IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
//  implied. See the License for the specific language governing
//  rights and limitations under the License.
//
//  Alternatively, the contents of this file may be used under the
//  terms of the GNU General Public License Version 2 or later (the
//  "GPL"), in which case the provisions of the GPL are applicable
//  instead of those above. If you wish to allow use of your version
//  of this file only under the terms of the GPL, and not to allow
//  others to use your version of this file under the terms of the
//  CPL, indicate your decision by deleting the provisions above and
//  replace them with the notice and other provisions required by the
//  GPL. If you do not delete the provisions above, a recipient may
//  use your version of this file under the terms of either the CPL or
//  the GPL.
//
/////////////////////////////////////////////////////////////

#include <vector>
#include "MersenneTwister.h"

using namespace std;

vector< vector<int> > random_settings( const int num_tests, const int num_parameters, const vector<int> par_levels, MTRand & randgen );

vector< vector<int> > limit_conflicts_settings( vector<vector<int> > test_settings, const int num_tests, const int num_parameters, const vector<int> par_levels, MTRand & randgen );

vector< vector<int> > pairwise_settings( const int num_tests, const int num_parameters, const vector<int> par_levels, MTRand & randgen, const int strength );

vector< vector<int> > exhaustive_settings( const int num_tests, const int num_parameters, const vector<int> par_levels );

vector< vector<int> > limit_conflicts_settings_subset( const int num_tests, const int num_parameters, const vector<int> par_levels, MTRand & randgen, vector<vector<int> > candidates );

